routes/web.php
<?php

use App\Http\Controllers\AwardsController;
use App\Http\Controllers\PointsController;
use App\Http\Controllers\ProfileController;
use App\Http\Controllers\SendAwardsController;
use App\Http\Controllers\UsersController;
use App\Http\Controllers\VounchersController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "web" middleware group. Make something great!
|
*/

Route::middleware('auth')->group(function () {

    Route::get('/', [UsersController::class, 'dashboard'])->name('dashboard');

    // USERS
    Route::middleware('admin')->prefix('usuarios')->group(function () {
        Route::name('users.')->group(function () {
            Route::get('/adicionar', [UsersController::class, 'create'])->name('create');
            Route::post('/adicionar', [UsersController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [UsersController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}', [UsersController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [UsersController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [UsersController::class, 'update'])->name('update');
            Route::get('/minha-conta', [UsersController::class, 'account'])->name('account');
            Route::put('/minha-conta', [UsersController::class, 'accountUp'])->name('accountUp');
            Route::get('/barra-lateral', [UsersController::class, 'aside'])->name('aside');
            Route::get('/aniversariantes', [UsersController::class, 'birthdays'])->name('birthdays');
            Route::get('/aprovar/{id}/{status}', [UsersController::class, 'aprove'])->name('aprove');
            Route::get('/ranking', [UsersController::class, 'ranking'])->name('ranking');
            Route::get('/{id?}', [UsersController::class, 'index'])->name('index');
        });
    });
    
    // USERS
    Route::prefix('pontos')->group(function () {
        Route::name('points.')->group(function () {
            Route::get('/', [PointsController::class, 'index'])->name('index');
            Route::post('/adicionar', [PointsController::class, 'store'])->name('store')->middleware('admin');
            Route::get('/pontuacao', [PointsController::class, 'table'])->name('table');
        });
    });
    
    // USERS
    Route::prefix('premios')->middleware('admin')->group(function () {
        Route::name('awards.')->group(function () {
            Route::get('/', [AwardsController::class, 'index'])->name('index');
            Route::get('/adicionar', [AwardsController::class, 'create'])->name('create');
            Route::post('/adicionar', [AwardsController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [AwardsController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}', [AwardsController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [AwardsController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [AwardsController::class, 'update'])->name('update');
        });
    });
    
    // USERS
    Route::prefix('envio-de-premios')->middleware('admin')->group(function () {
        Route::name('send.awards.')->group(function () {
            Route::get('/', [SendAwardsController::class, 'index'])->name('index');
            Route::get('/adicionar', [SendAwardsController::class, 'create'])->name('create');
            Route::post('/adicionar', [SendAwardsController::class, 'store'])->name('store');
            Route::get('/visualizando/{id}', [SendAwardsController::class, 'show'])->name('show');
            Route::get('/desabilitar/{id}/{status}', [SendAwardsController::class, 'destroy'])->name('destroy');
            Route::get('/editar/{id}', [SendAwardsController::class, 'edit'])->name('edit');
            Route::put('/editar/{id}', [SendAwardsController::class, 'update'])->name('update');
            Route::get('/email', [SendAwardsController::class, 'mail'])->name('email');
        });
    });
    
    Route::get('/solicitar', [AwardsController::class, 'results'])->name('awards.results');
    Route::get('/solicitar/{id}', [SendAwardsController::class, 'request'])->name('send.awards.request');

});

Route::get('/teste-email/{email?}', [SendAwardsController::class, 'mail'])->name('email');


require __DIR__.'/auth.php';

app/Models/User.php
<?php

namespace App\Models;

// use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Relations\HasMany;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Laravel\Sanctum\HasApiTokens;

class User extends Authenticatable
{
    use HasApiTokens, HasFactory, Notifiable;

    /**
     * The attributes that are mass assignable.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'name',
        'phone',
        'cpf',
        'birth',
        'role_id',
        'street',
        'number',
        'complement',
        'neighborhood',
        'city',
        'state',
        'status',
        'zip',
        'email',
        'password',
    ];

    /**
     * The attributes that should be hidden for serialization.
     *
     * @var array<int, string>
     */
    protected $hidden = [
        'password',
        'remember_token',
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
        'password' => 'hashed',
    ];

     /**
     * Get the comments for the blog post.
     */
    public function points(): HasMany
    {
        return $this->hasMany(Point::class);
    }

    

     /**
     * Get the comments for the blog post.
     */
    public function requestAwards(): HasMany
    {
        return $this->hasMany(SendAward::class);
    }

}

app/Http/Controllers/UsersController.php
<?php

namespace App\Http\Controllers;

use App\Mail\Notifications;
use App\Models\Award;
use App\Models\Point;
use App\Models\User;
use Carbon\Carbon;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Mail;
use Illuminate\Support\Facades\Storage;

class UsersController extends Controller
{
    protected $request;
    private $repository;
    
    public function __construct(Request $request, User $content)
    {
        
        $this->request = $request;
        $this->repository = $content;

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function dashboard()
    {

        // GET ALL DATA
        $users = User::orderBy('name', 'ASC')->get();
        $awards = Award::get();
        $points = Point::get();
        $currentMonth = Carbon::now()->month;
        $birthdays = User::whereMonth('birth', $currentMonth)
                        ->orderBy('name', 'ASC')
                        ->get();

        // RETURN VIEW WITH DATA
        return view('dashboard', [
            'users' => $users,
            'awards' => $awards,
            'points' => $points,
            'birthdays' => $birthdays,
        ]);

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($id = null)
    {

        if($id != null){
            $contents = User::where('role_id', $id)->orderBy('name', 'ASC')->get();
        } else {
            $contents = User::orderBy('name', 'ASC')->get();
        }

        // GET ALL DATA

        // RETURN VIEW WITH DATA
        return view('pages.users.index', [
            'contents' => $contents,
        ]);

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function ranking()
    {

        // GET ALL DATA
        $contents = User::orderBy('name', 'ASC')->get();

        // RETURN VIEW WITH DATA
        return view('pages.users.ranking', [
            'contents' => $contents,
        ]);

    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        // GET ALL DATA
        return view('pages.users.create');
    }

    // DEFINE FOLDER ROUTE
    public function folderRoute()
    {
        return "public/usuarios/";
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {

        // VERIFY IF TITLE IS UNIQUE
        $emailExist = User::where('email', $request->email)->count();

        if($emailExist > 0){
            if(!Auth::check() || Auth::user()->role_id != 1){
                return redirect()->route('register.email', $request->email );
            } else {
                // REDIRECT AND MESSAGES
                return redirect()
                 ->route('users.create')
                 ->with('message', 'Já existe um usuário com esse email.');
            }
        }

        // GET FORM DATA
        $data = $request->all();

        // CREATED BY
        $data['password'] = Hash::make($request->password);
        $data['created_by'] = Auth::id();

        if(!Auth::check() || Auth::user()->role_id != 1){
            $data['role_id'] = 2;
            $data['status'] = 2;
        }
        
        $data['birth'] = isset($data['birth']) ? convertDateFormat($data['birth']) : null; 

        // SEND DATA
        $insert = $this->repository->create($data);

        // CHECK IF THE USER SENT AN IMAGE AND VALIDATE
        storeImage($this->folderRoute(), $request->image, $insert->id);

        // REDIRECT AND MESSAGES
        if(!Auth::check() || Auth::user()->role_id != 1){
            return redirect()->route('register.thanks', $request->name);
        } else {
            return redirect()
                ->route('users.index')
                ->with('message', 'Usuário criado com sucesso.');
        }
        
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        // VERIFY IF EXISTS
        if(!$content = User::find($id)){
            return redirect()->back();
        }

        // GENERATES DISPLAY WITH DATA
        return view('pages.users.edit')->with([
            'content' => $content,  
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {

        // VERIFY IF TITLE IS UNIQUE
        $emailExist = User::where('email', $request->email)->where('id', '<>', $id)->count();

        if($emailExist > 0){
             // REDIRECT AND MESSAGES
                return redirect()
                ->route('users.edit', $id)
                ->with('message', 'Já existe um usuário com esse email.');
        }

        // GET FORM DATA
        $data = $request->all();     
        
        // CHECK IF THE USER SENT AN IMAGE AND VALIDATE
        storeImage($this->folderRoute(), $request->image, $id);

        // VERIFY IF PASSWORD
            if ($data['password'] != '') {
                $data['password'] = Hash::make($request->password);
            } else {
                unset($data['password']);
            }
        
        // UPDATE BY
        $data['updated_by'] = Auth::id();
        $data['birth'] = isset($data['birth']) ? convertDateFormat($data['birth']) : null; 

        // STORING NEW DATA
        $content = User::find($id);
        $content->update($data);

        // REDIRECT AND MESSAGES
        return redirect()
        ->route('users.edit', $id)
        ->with('message', 'Usuário atualizado com sucesso.');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        
        // GET DATA
        $content = User::find($id);

        // STORING NEW DATA
        if($content->status == 1){
            User::where('id', $id)->update(['status' => 0]);
            $message = 'desabilitado';
        } else {
            User::where('id', $id)->update(['status' => 1]);
            $message = 'habilitado';
        }
        

        // REDIRECT AND MESSAGES
        return redirect()
        ->route('users.index')
        ->with('message', 'Usuário <b>'. $content->name . '</b> '. $message .' com sucesso.');

    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function account()
    {
        // VERIFY IF EXISTS
        if(!$content = User::find(Auth::id())){
            return redirect()->back();
        }

        // GENERATES DISPLAY WITH DATA
        return view('pages.users.account')->with([
            'content' => $content,
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function accountUp(Request $request)
    {

        // VERIFY IF EXISTS

        if(!$content = $this->repository->find(Auth::id()))
        return redirect()->back();

        // GET FORM DATA
        $data = $request->all();

        // VERIFY IF PASSWORD
        if($data['password'] != ''){
            // STORING NEW DATA
            User::where('id', Auth::id())->update([
                'password' => Hash::make($request->password),
            ]);
        } else {
            unset($data['password']);
        }

        // UPDATE BY
        $data['updated_by'] = Auth::id();

        // UPDATE ACCOUNT
        $content->update($data);

        // CHECK IF THE USER SENT AN IMAGE AND VALIDATE
        storeImage($this->folderRoute(), $request->image, $content->id);

        // REDIRECT AND MESSAGES
        return redirect()
        ->route('users.account')
        ->with('message', 'Conta atualizada com sucesso.');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function birthdays()
    {

        // GET ALL DATA
        $currentMonth = Carbon::now()->month;
        $contents = User::whereMonth('birth', $currentMonth)
                        ->orderBy('name', 'ASC')
                        ->get();
                        
        // RETURN VIEW WITH DATA
        return view('pages.users.birthdays', [
            'contents' => $contents,
        ]);

    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function thanks($name)
    {
        // RETURN VIEW WITH DATA
        return view('auth.thank')->with('name', $name);
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function email($email)
    {
        // RETURN VIEW WITH DATA
        return view('auth.email')->with('email', $email);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function aprove($id, $status)
    {
        
        // GET DATA
        $content = User::find($id);
        $content->status = $status;

        if($content->save()){

            // EMAIL
            $email = $content->email;

            // PARAMETERS FROM EMAIL
            $parameters = [
                'fromName' => 'Dalmóbile',
                'fromEmail' => 'smtp@dreamake.com.br',

resources/views/pages/users/account.blade.php
@extends('layouts.app')

@section('page-title', 'Minha Conta')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid pt-10">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 m-0 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <form action="{{ route('users.accountUp') }}" method="POST" enctype="multipart/form-data">
                                @method('PUT')
                                @csrf
                                <div class="row gx-10 mb-5">
                                    @include('pages._forms.user')
                                    <div class="d-flex justify-content-between mt-5">
                                        <div>
                                            <a href="{{ route('users.index') }}">
                                                <label class="btn btn-light text-muted ml-2">Voltar</label>
                                            </a>
                                        </div>
                                        <div>
                                            <input type="submit" class="btn btn-primary btn-active-danger text-light mb-3" value="Atualizar"></input>
                                        </div>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
</div>
<!--end::Content-->
@endsection

resources/views/pages/users/create.blade.php
@extends('layouts.app')

@section('page-title', 'Adicionar Usuário')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid pt-10">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 m-0 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <form action="{{ route('users.store') }}" method="POST" enctype="multipart/form-data">
                                @csrf
                                <div class="row gx-10 mb-5">
                                    @include('pages._forms.user')
                                    <div class="d-flex justify-content-end mt-5">
                                        <input type="submit" class="btn btn-primary btn-active-danger mb-3" value="Cadastrar"></input>
                                    </div>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
</div>
<!--end::Content-->
@endsection

resources/views/pages/users/index.blade.php
@extends('layouts.app')

@section('page-title', 'Usuários')

@section('url-toolbar', route('users.create'))

@section('text-toolbar', 'Adicionar Usuário')

@section('content')
<!--begin::Content-->
<div id="kt_app_content" class="app-content flex-column-fluid">
    <!--begin::Content container-->
    <div id="kt_app_content_container" class="app-container container-fluid">
        <!--begin::Container-->
        <div id="kt_content_container" class="container-fluid">
            <!--begin::Row-->
            <div class="row g-5 g-xl-8">
                <div class="col-xl-12 p-0">
                    <div class="card">
                        <div class="card-body fs-6 p-10 text-gray-700">
                            <table id="datatables" class="table table-striped table-row-bordered gy-5 gs-7 border rounded">
                                <thead>
                                    <tr class="fw-bold fs-6 text-gray-800 px-7">
                                        <th>ID</th>
                                        <th>Nome</th>
                                        <th>Tipo</th>
                                        <th>Pontos</th>
                                        <th>Telefone</th>
                                        <th>E-mail</th>
                                        <th>Status</th>
                                        <th>Ações</th>
                                    </tr>
                                </thead>
                                <tbody class="table-pd">
                                    @foreach ($contents as $content)
                                    <tr>
                                        <td>
                                            <span class="text-gray-700">{{ $content->id }}</span>
                                        </td>
                                        <td style="min-width: 25%; padding: 11px;">
                                            <div class="d-flex align-items-center">
                                                <div class="symbol symbol-30px me-5">
                                                    <img src="{{ searchImage('usuarios', $content->id, true, true) }}" class="rounded object-fit-cover" alt="">
                                                </div>
                                                <div class="d-flex justify-content-start">
                                                    <a href="{{ route('users.edit', $content->id) }}" class="text-gray-700 fw-bold text-hover-primary fs-6">{{ Str::limit($content->name, 20) }}</a>
                                                </div>
                                            </div>
                                        </td>
                                        <td>
                                            @if ($content->role_id == 1)
                                                <span class="badge badge-light-danger">Administrador</span>
                                            @elseif($content->role_id == 2)
                                                <span class="badge badge-light-info">Arquiteto</span>
                                            @else
                                                <span class="badge badge-light-primary">Decorador</span>
                                            @endif
                                        </td>
                                        <td class="text-gray-700">
                                            @if($content->points->sum('points') != 0)
                                            <span class="badge @if($content->points->sum('points') < 0) badge-light-danger @else badge-light-success @endif">
                                                {{ $content->points->sum('points') }}
                                            </span>
                                            @else
                                            <span class="badge badge-light">
                                               Sem pontos
                                            </span>
                                            @endif
                                        </td>
                                        <td class="text-gray-700">
                                            @if ($content->phone != null)
                                                <span class="badge badge-light-primary">{{ $content->phone }}</span>
                                            @else
                                                <span class="badge badge-light">Sem telefone</span>
                                            @endif
                                        </td>
                                        <td class="text-gray-700">
                                            <div class="d-flex align-items-center">
                                                {{ $content->email }}
                                            </div>
                                        </td>
                                        <td class="text-gray-700">
                                            <div class="d-flex align-items-center">
                                                @if($content->status == 1)
                                                <span class="badge badge-light-primary">Ativo</span>
                                                @elseif($content->status == 2)
                                                <span class="badge badge-light-warning">Pendente</span>
                                                @else
                                                <span class="badge badge-light-danger">Inativo</span>
                                                @endif
                                            </div>
                                        </td>
                                        <td>
                                            <div class="d-flex align-items-center icons-edit">
                                                <a href="{{ route('users.edit', $content->id) }}">
                                                    <i class="fas fa-edit ps-1" title="Editar"></i>
                                                </a>
                                                @if($content->status == 2)
                                                <a href="{{ route('users.aprove', ['id' => $content->id, 'status' => 1]) }}">
                                                    <i class="fa-solid fa-circle-check ps-1" title="Aprovar"></i>
                                                </a>
                                                @endif
                                                @if($content->status == 2)
                                                <a href="{{ route('users.aprove', ['id' => $content->id, 'status' => 0]) }}">
                                                    <i class="fa-solid fa-circle-xmark ps-1" title="Recusar"></i>
                                                </a>
                                                @endif
                                                @if($content->status == 1)
                                                <a href="{{ route('users.destroy', $content->id) }}">
                                                    <i class="fas fa-times-circle ps-1" title="Desativar"></i>
                                                </a>
                                                @else
                                                <a href="{{ route('users.destroy', $content->id) }}">
                                                    <i class="fas fa-redo ps-1" title="Reativar"></i>
                                                </a>
                                                @endif
                                            </div>
                                        </td>
                                    </tr> 
                                    @endforeach
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
            <!--end::Row-->
        </div>
        <!--end::Container-->
    </div>
    <!--end::Post-->
</div>
<!--end::Content-->
@endsection